'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


' <fileinfo name="OrderDetailsFactory.vb">
'		<author></author>
'		<creation-datetime>Tue Jun 07 04:35:01 2005</creation-datetime>
'		<description>
'			Contains VB.NET code OrderDetailsFactory.
'		</description>
'		<remarks>
'			Changes to this file will be lost if the code is regenerated.
'		</remarks>
' </fileinfo>
 
Imports System
Imports System.Data
Imports System.Text
Imports System.Globalization
Imports System.Resources
Imports System.Threading
Imports System.Reflection
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework 

Imports System.Data.OleDb

Namespace NCacheSample
    Public Interface IOrderDetailsFactory
        Function Load(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnalbed As Boolean)
        Function Insert(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Update(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Delete(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        'Function Save(ByRef objList As OrderDetailsCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean, ByVal strCacheKey As String)
        Function DeleteColl(ByRef objList As OrderDetailsCollection, ByVal nDepth As Int32)
        'Function ProcessDataSet(ByVal dataSet As DataSet)

        Function FindByOrders(ByVal n32prmOrderID As Int32, ByVal bCacheEnabled As Boolean) As OrderDetailsCollection
        Function FindByOrdersCount(ByVal n32prmOrderID As Int32) As Int32
        Function FindByOrdersPR(ByVal nSP As Int32, ByVal nRecords As Int32, ByVal n32prmOrderID As Int32) As OrderDetailsCollection
        Function DeleteByOrders(ByVal n32prmOrderID As Int32) As Integer
    End Interface

    ''' <summary>
    ''' Object <c>OrderDetails</c>Factory. Provides implementation.
    ''' </summary>
    ''' <remarks>
    '''		
    ''' </remarks>
    <ClassInterface(ClassInterfaceType.AutoDual)> _
        Public Class OrderDetailsFactory
        Inherits DbObject
        Implements IOrderDetailsFactory
        ' define constants here for either dynamic SQL or stored procedure calls

        Private Shared _stQryObject As String
        Private Shared _stPKQryObject As String
        Private Shared _stRelObject As String
        Private Const _stObjectName As String = "OrderDetails"
        Private Const USE_STORE_PROC As Boolean = False
        Private Const STD_LOAD_SQL As String = _
            "SELECT" & _
            "     a15.[OrderID] as OrderID, a15.[ProductID] as ProductID," & _
            "     a15.[UnitPrice] as UnitPrice, a15.[Quantity] as Quantity," & _
            "     a15.[Discount] as Discount" & _
            " FROM" & _
            "     [Order Details] a15" & _
            " WHERE" & _
            "     [ProductID] = ? AND [OrderID] = ?"
        Private Const STD_INSERT_SQL As String = _
            "INSERT INTO [Order Details]" & _
            "    ([OrderID], [ProductID]" & _
            "     , [UnitPrice], [Quantity]" & _
            "     , [Discount]) VALUES (?, ?" & _
            "     , ?, ?" & _
            "     , ?)"
        Private Const STD_DELETE_SQL As String = _
            "DELETE FROM [Order Details] WHERE [ProductID] = ? AND [OrderID] = ?"
        Private Const STD_UPDATE_SQL As String = _
            "UPDATE" & _
            "     [Order Details]" & _
            " SET" & _
            "     [UnitPrice] = ?, [Quantity] = ?," & _
            "     [Discount] = ?" & _
            " WHERE" & _
            "     [ProductID] = ? AND [OrderID] = ?"
        Private Const FindByOrders_SQL As String = _
            "SELECT" & _
            "     a15.[OrderID] as OrderID, a15.[ProductID] as ProductID," & _
            "     a15.[UnitPrice] as UnitPrice, a15.[Quantity] as Quantity," & _
            "     a15.[Discount] as Discount" & _
            " FROM" & _
            "     [Order Details] a15" & _
            " WHERE" & _
            "     (a15.[OrderID] = ?)"

        Private Const FindByOrdersCount_SQL As String = _
            "SELECT" & _
            "    COUNT(*)" & _
            " FROM" & _
            "     [Order Details] a15" & _
            " WHERE" & _
            "     (a15.[OrderID] = ?)"
        Private Const DeleteByOrders_SQL As String = _
            "DELETE FROM" & _
            "     [Order Details]" & _
            " WHERE ([OrderID] = ?)"



        ' second argument to base() is a flag about whether we're using stored procedures
        ' or dynamic SQL; true = storedProc, false = dynamic sql
        'TDevFramework.PropertyFile.CreateInstance("DbConnStr.db").LoadProperty("OrderDetails")
        Public Sub New()
            MyBase.new("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\NorthwindDB\Northwind.mdb;User Id=;Password=;", TDevFramework.EDBProvider.OLEDB)
        End Sub



        Public Sub New(ByVal connectionString As String)
            MyBase.new(connectionString, TDevFramework.EDBProvider.OLEDB)
        End Sub

        Public Sub New(ByVal connection As TDevFramework.Connection)
            MyBase.new(connection)
        End Sub

        Public Sub New(ByVal connection As Object)
            MyBase.new(connection, TDevFramework.EDBProvider.OLEDB)
        End Sub

#Region "[Cache Keys]"
        Private Function GetPKQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".PKQry" ' A dummy key ...
            If _stPKQryObject = "" Then
                _stPKQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stPKQryObject, Nothing)
            End If
            GetPKQueryKey = key
        End Function
        Private Function GetQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".NonPKQry" ' A dummy key ...
            If _stQryObject = "" Then
                _stQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stQryObject, Nothing)
            End If
            GetQueryKey = key
        End Function

        Private Function GetRelatedKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".Rel" ' A dummy key
            If _stRelObject Is Nothing Then
                _stRelObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stRelObject, Nothing)
            End If
            GetRelatedKey = key
        End Function

        Private Sub InvalidateAll()
            NCacheUtil.Remove(GetQueryKey()) '
            NCacheUtil.Remove(GetRelatedKey()) '
            NCacheUtil.Remove(GetPKQueryKey()) '
            _stRelObject = Nothing '
            _stQryObject = Nothing
        End Sub
        Private Sub Invalidate(ByVal type As NCacheUtil.InvalidateType, ByVal ParamArray relatedKeys As String())
            '_staticObject = "INVALIDATED"
            'NCacheUtil.Insert(GetStaticObjectKey(),_staticObject,Nothing)
            '_staticObject = Nothing'
            If ((type Or NCacheUtil.InvalidateType.QueryCollectionPK) = NCacheUtil.InvalidateType.QueryCollectionPK) Then
                If _stPKQryObject <> "" Then
                    NCacheUtil.Remove(GetPKQueryKey())
                    _stPKQryObject = Nothing
                End If
            End If
            If ((type Or NCacheUtil.InvalidateType.QueryCollection) = NCacheUtil.InvalidateType.QueryCollection) Then
                If _stQryObject <> "" Then
                    NCacheUtil.Remove(GetQueryKey())
                    _stQryObject = Nothing
                End If
            End If
            If ((type Or NCacheUtil.InvalidateType.RelatedCollection) = NCacheUtil.InvalidateType.RelatedCollection) Then
                NCacheUtil.Remove(relatedKeys)
                _stRelObject = Nothing
            End If
        End Sub

        Private Function GetRelatedKeys(ByVal objInfo As Object) As String()
            Dim keys(0) As String
            keys(0) = NCacheUtil.GetRelationKey("Orders", "OrderDetails", objInfo.OrderID.ToString())

            GetRelatedKeys = keys
        End Function
#End Region

#Region "[Cache Operations]"

        Private Function InsertOrderCache(ByRef objInfo As OrderDetails)

            Dim _orderDetailColl As OrderDetailsCollection
            Dim _orderDetails As OrderDetails
            Dim cacheKeys As ArrayList
            Dim ColKey As String
            'Dim objKey As String

            'objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
            ColKey = NCacheUtil.GetRelationKey("Orders", "OrderDetails", objInfo.OrderID.ToString())

            _orderDetailColl = NCacheUtil.Load(ColKey) ' trying to get the related collection from cache..
            ' Inserting new object into cache...
            'NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))

            If Not _orderDetailColl Is Nothing Then

                Dim index As Int32
                index = _orderDetailColl.IsContain(objInfo) ' In case of heap ...
                If index < 0 Then ' In case out proc ..
                    _orderDetailColl.Add(objInfo)
                End If
                cacheKeys = New ArrayList
                For Each _orderDetails In _orderDetailColl
                    cacheKeys.Add(NCacheUtil.GetObjectKey("OrderDetails", _orderDetails.OrderID.ToString(), _orderDetails.ProductID.ToString()))
                Next
                If cacheKeys.Count > 0 Then
                    cacheKeys.Add(GetRelatedKey())
                    NCacheUtil.Insert(ColKey, _orderDetailColl, cacheKeys, DateTime.Now.AddMinutes(30))
                End If
            End If
            'Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing)
            'Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, GetRelatedKeys(objInfo))
        End Function

        Private Function DeleteOrderCache(ByRef objInfo As OrderDetails)

            Dim _orderDetailColl As OrderDetailsCollection
            Dim _orderDetails As OrderDetails
            Dim cacheKeys As ArrayList
            Dim ColKey As String
            'Dim objKey As String

            'objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
            ColKey = NCacheUtil.GetRelationKey("Orders", "OrderDetails", objInfo.OrderID.ToString())

            _orderDetailColl = NCacheUtil.Load(ColKey)

            If Not _orderDetailColl Is Nothing Then
                Dim index As Int32
                index = _orderDetailColl.IsContain(objInfo)
                If Not index < 0 Then
                    _orderDetailColl.RemoveAt(index) ' Updating the object...
                    '_orderDetailColl.MarkedDeletedItems.RemoveAt(_orderColl.MarkedDeletedItems.Count)
                    _orderDetailColl.MarkedDeletedItems.Clear()
                End If
                cacheKeys = New ArrayList
                For Each _orderDetails In _orderDetailColl
                    cacheKeys.Add(NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString()))
                Next
            End If

            If cacheKeys.Count > 0 Then
                cacheKeys.Add(GetRelatedKey())
                NCacheUtil.Insert(ColKey, _orderDetailColl, cacheKeys, DateTime.Now.AddMinutes(30))
            End If
            'NCacheUtil.Remove(objKey)
            'Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK
        End Function

        Private Function UpdateOrderCache(ByRef objInfo As OrderDetails)

            Dim _orderDetailColl As OrderDetailsCollection
            Dim _orderDetails As OrderDetails
            Dim cacheKeys As ArrayList
            Dim ColKey As String
            'Dim objKey As String

            'objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
            ColKey = NCacheUtil.GetRelationKey("Orders", "OrderDetails", objInfo.OrderID.ToString())

            _orderDetailColl = NCacheUtil.Load(ColKey)

            If Not _orderDetailColl Is Nothing Then
                Dim index As Int32
                index = _orderDetailColl.IsContain(objInfo)
                If Not index < 0 Then
                    _orderDetailColl.item(index).Copy(objInfo) ' Updating the object...
                    cacheKeys = New ArrayList
                    For Each _orderDetails In _orderDetailColl
                        cacheKeys.Add(NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString()))
                    Next
                End If
            End If

            If cacheKeys.Count > 0 Then
                cacheKeys.Add(GetRelatedKey())
                NCacheUtil.Insert(ColKey, _orderDetailColl, cacheKeys, DateTime.Now.AddMinutes(30))
            End If

            'NCacheUtil.Insert(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
            'Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK
        End Function
#End Region

#Region " Standard Methods "


        ' <summary>
        ' 	Load (Standard Load Method [Cache Enabled])
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Order Details]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>OrderDetails</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>
        Public Function Load(ByRef objInfo As OrderDetails, ByVal nDepth As Integer, ByVal bCacheEnable As Boolean) _
        Implements IOrderDetailsFactory.Load

            Dim objKey As String
            Dim obj As Object

            objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())

            Try
                If bCacheEnable Then
                    obj = NCacheUtil.Load(objKey) ' Check if the object is in Cache. 
                    If obj Is Nothing Then ' Cache miss..
                        _Load(objInfo, nDepth, bCacheEnable)
                        Stats.ReadTripsToDB = 1
                        Stats.ObjsReadFromDB = 1
                        NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                        Exit Function
                    End If
                    Stats.ObjsReadFromCache = 1
                    'objInfo.Copy(CType(obj, OrderDetails)) ' Cache hit..

                    Dim objTemp As OrderDetails = CType(obj, OrderDetails)
                    objInfo.Copy(objTemp) ' Cache hit..

                    If nDepth <> 0 Then
                        LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                    End If
                Else
                    _Load(objInfo, nDepth, bCacheEnable)
                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1
                    End If
                    Stats.ObjsReadFromDB = 1
                    Stats.ReadTripsToDB = 1
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                End If
            Catch e As Exception
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Load (Standard Load Method)
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Order Details]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>OrderDetails</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>


        Private Function _Load(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)

            Try
                Dim bRecordsFound As Boolean = False
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_LOAD_SQL, USE_STORE_PROC)

                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))
                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))
                ExecuteReader()
                While (Read())
                    FillPersistentObject(objInfo)
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    bRecordsFound = True
                End While
                ReleaseReader()
                If Not bRecordsFound Then
                    Throw New RecordNotFoundException("No record found against given search criteria.")
                End If

                If (nDepth <> 0) Then
                    LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

            Catch e As RecordNotFoundException
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Throw e
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Insert (Standard Insert Method)
        ' </summary>
        ' <remarks>
        ' 	Adds a new record into the <c>[Order Details]</c> table.
        ' </remarks>
        ' <param name="objInfo">The <c>OrderDetails</c> info object to be inserted.</param>
        ' <param name="nDepth">Specifies depth of children should be inserted.</param>

        Public Function Insert(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IOrderDetailsFactory.Insert
            Try

                objInfo.ValidateRequiredFields()

                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))

                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))

                'Read the persistent object
                ReadPersistentObject(objInfo)
                ExecuteNonQuery()
                ReleaseReader()


                If (nDepth <> 0) Then
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.IsNew = False
                objInfo.Dirty = False

                Stats.WriteTripsToDB = 1
                If bCacheEnable Then
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30)) ' Store the new object into cache...

                    InsertOrderCache(objInfo)
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing)
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function
        Private Function _Insert(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)

            Try

                objInfo.ValidateRequiredFields()

                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))

                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))

                'Read the persistent object
                ReadPersistentObject(objInfo)
                ExecuteNonQuery()
                ReleaseReader()


                If (nDepth <> 0) Then
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.IsNew = False
                objInfo.Dirty = False

                Stats.WriteTripsToDB = 1
                If bCacheEnable Then
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30)) ' Store the new object into cache...
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing)
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Delete (Standard Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Deletes the record in <c>[Order Details]</c> table given
        '   by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>OrderDetails</c> info object used to delete the record.</param>
        ' <param name="nDepth">Specifies depth of children should be deleted.</param>

        Public Function Delete(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IOrderDetailsFactory.Delete
            Try

                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_DELETE_SQL, USE_STORE_PROC)

                If (nDepth <> 0) Then
                End If
                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))
                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))
                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1


                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                If bCacheEnable Then

                    DeleteOrderCache(objInfo)
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
                    NCacheUtil.Remove(objKey)
                    Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Update (Standard Update Method)
        ' </summary>
        ' <remarks>
        ' 	Updates the record in <c>[Order Details]</c> table given
        ' by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>OrderDetails</c> info object used to update the record.</param>
        ' <param name="nDepth">Specifies depth of children should be updated.</param>

        Public Function Update(ByRef objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IOrderDetailsFactory.Update
            Try

                CheckPrimaryKeyValues(objInfo)
                objInfo.ValidateRequiredFields()
                Prepare(STD_UPDATE_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                ReadPersistentObject(objInfo)
                AddCmdParameter("@OrderID", TDevFramework.EDataType.eInt, objInfo.OrderID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("OrderID"))
                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))

                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1

                If (nDepth <> 0) Then
                End If
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.Dirty = False

                If bCacheEnable Then

                    UpdateOrderCache(objInfo)
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
                    NCacheUtil.Insert(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK

                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

#End Region


        Private Function Save(ByRef objList As OrderDetailsCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean, ByVal strCacheKey As String)

            Dim objInfo As OrderDetails = Nothing
            Dim count As Integer
            Dim orderId As Integer
            Dim objKey As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim remKeys(objList.MarkedDeletedItems.Count - 1) As String
            Dim bFlag As Boolean = False

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), OrderDetails)
                Me.Delete(objInfo, nDepth, bCacheEnable)
                remKeys(count) = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString())
            Next count

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                orderId = objInfo.OrderID
                If (objInfo.IsNew) Then
                    Me._Insert(objInfo, nDepth, bCacheEnable)
                    If bCacheEnable Then
                        Stats.WriteTripsToDBWithCache = 1
                        Stats.ObjsWrittenToDBWithCache = 1
                        bFlag = True
                    Else
                        Stats.WriteTripsToDB = 1
                        Stats.ObjsWrittenToDB = 1
                    End If
                ElseIf (objInfo.Dirty) Then
                    Me.Update(objInfo, nDepth, bCacheEnable)
                    If bCacheEnable Then
                        Stats.WriteTripsToDBWithCache = 1
                        Stats.ObjsWrittenToDBWithCache = 1
                        bFlag = True
                    Else
                        Stats.WriteTripsToDB = 1
                        Stats.ObjsWrittenToDB = 1
                    End If
                End If

                If bCacheEnable Then
                    objKey = NCacheUtil.GetObjectKey(_stObjectName, objInfo.OrderID.ToString())
                    cacheKeys.Add(objKey)
                End If


            Next count

            If bFlag Then
                cacheKeys.Add(GetRelatedKey())
                NCacheUtil.Insert(strCacheKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                NCacheUtil.Remove(remKeys)
            End If

        End Function

        Public Function Save(ByRef objList As OrderDetailsCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean, ByVal objParent As Orders)
            Dim strCacheKey As String

            strCacheKey = NCacheUtil.GetRelationKey("Orders", "OrderDetails", objList(0).OrderID.ToString())
            Me.Save(objList, nDepth, bCacheEnable, strCacheKey)

        End Function


        ' <summary>
        ' 	DeleteColl (Standard Collection Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Performs standard delete on a collection of <c>OrderDetails</c> objects.
        ' </remarks>
        ' <param name="objList">The <c>OrderDetailsCollection</c> object.</param>
        ' <param name="nDepth">integer that is passed to each delete operation.</param>		

        Public Function DeleteColl(ByRef objList As OrderDetailsCollection, ByVal nDepth As Int32) _
                  Implements IOrderDetailsFactory.DeleteColl

            Dim objInfo As OrderDetails = Nothing
            Dim count As Integer

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                If (Not objInfo.IsNew) Then
                    Me.Delete(objInfo, nDepth, True)
                End If
            Next count

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), OrderDetails)
                Me.Delete(objInfo, nDepth, True)
            Next count

        End Function



#Region " Queries "

        ' <summary>
        ' 	FindByOrders (Query Method)
        ' </summary>
        ' <remarks>
        ' 	
        ' </remarks>
        ' <returns><c>OrderDetailsCollection</c> object containing all the records 
        '	returned in the resultset.</returns>

        Public Function FindByOrders(ByVal n32prmOrderID As Int32, ByVal bCacheEnable As Boolean) As OrderDetailsCollection _
         Implements IOrderDetailsFactory.FindByOrders

            Dim objKey As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim obj As Object

            objKey = NCacheUtil.GetRelationKey("Orders", "OrderDetails", n32prmOrderID.ToString())

            If bCacheEnable Then
                obj = NCacheUtil.Load(objKey) ' Try to load from Cache...
                If Not obj Is Nothing Then
                    Stats.ObjsReadFromCache = CType(obj, OrderDetailsCollection).Count
                    Return CType(obj, OrderDetailsCollection) ' Return from Cache..
                End If
            End If

            Dim objInfo As OrderDetails
            Dim objList As OrderDetailsCollection = New OrderDetailsCollection

            Try

                Prepare(FindByOrders_SQL, USE_STORE_PROC)

                AddCmdParameter("@prmOrderID", TDevFramework.EDataType.eInt, n32prmOrderID, EParamDirection.eInput)
                ExecuteReader()
                While (Read())
                    objInfo = New OrderDetails
                    If (Not IsNull("OrderID")) Then
                        objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                    End If
                    If (Not IsNull("ProductID")) Then
                        objInfo.ProductID = Convert.ToInt32(getValue("ProductID"))
                    End If
                    If (Not IsNull("UnitPrice")) Then
                        objInfo.UnitPrice = Convert.ToDecimal(getValue("UnitPrice"))
                    End If
                    If (Not IsNull("Quantity")) Then
                        objInfo.Quantity = Convert.ToInt16(getValue("Quantity"))
                    End If
                    If (Not IsNull("Discount")) Then
                        objInfo.Discount = Convert.ToSingle(getValue("Discount"))
                    End If
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    objList.Add(objInfo)
                    Stats.ObjsReadFromDB = 1

                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1

                        Dim key As String
                        key = NCacheUtil.GetObjectKey("OrderDetails", objInfo.OrderID.ToString(), objInfo.ProductID.ToString())
                        cacheKeys.Add(key)
                        NCacheUtil.Store(key, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    End If

                End While


                ReleaseReader()
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.ReadTripsToDB = 1

                If bCacheEnable Then
                    Stats.ReadTripsToDBWithCache = 1
                    If cacheKeys.Count > 0 Then
                        cacheKeys.Add(GetRelatedKey())
                        NCacheUtil.Store(objKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                    End If
                End If


            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try

            Return objList
        End Function


        ' <summary>
        ' 	FindByOrdersCount (Query Method)
        ' </summary>
        ' <remarks>
        ' 	This method executes the query and returns the number of records returned in the resultset.
        ' 	See Also: <seealso cref="FindByOrders"/>. 
        ' </remarks>
        ' <returns>Number of records returned in the resultset.</returns>		

        Public Function FindByOrdersCount(ByVal n32prmOrderID As Int32) As Int32 _
          Implements IOrderDetailsFactory.FindByOrdersCount

            Dim recordCount As Int32 = 0
            Try

                Prepare(FindByOrdersCount_SQL, False)
                AddCmdParameter("@prmOrderID", TDevFramework.EDataType.eInt, n32prmOrderID, EParamDirection.eInput)
                recordCount = CType(ExecuteScalar(), Int32)
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return recordCount
        End Function


        ' <summary>
        ' 	FindByOrdersPR (Query Method)
        ' </summary>
        ' <remarks>
        ' 	This method executes the query and returns the number of records returned in the resultset.
        ' 	See Also: <seealso cref="FindByOrders"/>. 
        ' </remarks>
        ' <returns><c>OrderDetailsCollection</c> object containing the specified number of records 
        '	starting from index '<c>nSP</c>' in the resultset.</returns>		

        Public Function FindByOrdersPR(ByVal nSP As Int32, ByVal nRecords As Int32, ByVal n32prmOrderID As Int32) As OrderDetailsCollection _
         Implements IOrderDetailsFactory.FindByOrdersPR

            Dim count As Integer = 0
            Dim objInfo As OrderDetails
            Dim objList As OrderDetailsCollection = New OrderDetailsCollection

            Try
                nSP -= 1
                If (nSP < 0) Then
                    nSP = 0
                End If

                Prepare(FindByOrders_SQL, USE_STORE_PROC)

                AddCmdParameter("@prmOrderID", TDevFramework.EDataType.eInt, n32prmOrderID, EParamDirection.eInput)
                ExecuteReader()
                While (Read())
                    If (count > (nRecords + nSP)) Then
                        Exit While
                    End If
                    If ((count >= nSP) And (count < (nRecords + nSP))) Then
                        objInfo = New OrderDetails
                        If (Not IsNull("OrderID")) Then
                            objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
                        End If
                        If (Not IsNull("ProductID")) Then
                            objInfo.ProductID = Convert.ToInt32(getValue("ProductID"))
                        End If
                        If (Not IsNull("UnitPrice")) Then
                            objInfo.UnitPrice = Convert.ToDecimal(getValue("UnitPrice"))
                        End If
                        If (Not IsNull("Quantity")) Then
                            objInfo.Quantity = Convert.ToInt16(getValue("Quantity"))
                        End If
                        If (Not IsNull("Discount")) Then
                            objInfo.Discount = Convert.ToSingle(getValue("Discount"))
                        End If
                        objInfo.IsNew = False
                        objInfo.Dirty = False
                        objList.Add(objInfo)
                    End If
                    count += 1
                End While


                If (count = 0) Then
                    Throw New Exception("No record found against this criteria")
                ElseIf (Not (count = 0)) Then
                    nSP += 1
                    If (nSP > count) Then
                        Dim strMsg As String = "There are " + count.ToString() + " records in the table. "
                        strMsg = strMsg + "Hence the given staring index is invalid."
                        Throw New Exception(strMsg)
                    ElseIf (nRecords > count) Then
                        Dim strMsg As String = "There are " + count.ToString() + " records in the table. "
                        strMsg = strMsg + "Hence the given parameter for records to display is out of range."
                        Throw New Exception(strMsg)
                    ElseIf ((nRecords + nSP - 1) > count) Then
                        Dim strMsg As String = "There are " + count.ToString() + " records in the table. "
                        strMsg = strMsg + "Hence the given parameters are out of range."
                        Throw New Exception(strMsg)
                    End If

                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function



#End Region

#Region " Bulk Update Operations "

#End Region

#Region " Bulk Delete Operations "

        ' <summary>
        ' 	DeleteByOrders (Bulk Delete Method)
        ' </summary>
        ' <remarks>
        ' 	<para>Deletes all the record in <c>[Order Details]</c> table matching the given criteria.</para>
        ' 	<para>
        ' 	
        ' 	</para>
        ' </remarks>
        ' <returns>The number of rows affected.</returns>	

        Public Function DeleteByOrders(ByVal n32prmOrderID As Int32) As Integer _
                  Implements IOrderDetailsFactory.DeleteByOrders

            Dim result As Integer = 0
            Try
                Prepare(DeleteByOrders_SQL, USE_STORE_PROC)

                AddCmdParameter("@prmOrderID", TDevFramework.EDataType.eInt, n32prmOrderID, EParamDirection.eInput)
                result = ExecuteNonQuery()


                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                Dim cachekey(0) As String
                cachekey(0) = "Orders." + n32prmOrderID + ".OrderDetails"
                Invalidate(NCacheUtil.InvalidateType.RelatedCollection And NCacheUtil.InvalidateType.QueryCollection And NCacheUtil.InvalidateType.QueryCollectionPK, cachekey)
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return result
        End Function

#End Region

#Region " Custom Insert Operations "

#End Region

#Region " Custom Update Operations "

#End Region

#Region " Custom Load Operations "

#End Region

#Region " Stored Procedures "

#End Region

#Region " Utility Methods "

        Private Function FillPersistentObject(ByVal objInfo As OrderDetails)

            If (Not IsNull("OrderID")) Then
                objInfo.OrderID = Convert.ToInt32(getValue("OrderID"))
            End If
            If (Not IsNull("ProductID")) Then
                objInfo.ProductID = Convert.ToInt32(getValue("ProductID"))
            End If
            If (Not IsNull("UnitPrice")) Then
                objInfo.UnitPrice = Convert.ToDecimal(getValue("UnitPrice"))
            End If
            If (Not IsNull("Quantity")) Then
                objInfo.Quantity = Convert.ToInt16(getValue("Quantity"))
            End If
            If (Not IsNull("Discount")) Then
                objInfo.Discount = Convert.ToSingle(getValue("Discount"))
            End If

        End Function

        Private Function ReadPersistentObject(ByVal objInfo As OrderDetails)

            AddCmdParameter("@UnitPrice", TDevFramework.EDataType.eDecimal, objInfo.UnitPrice, TDevFramework.EParamDirection.eInput, objInfo.IsNull("UnitPrice"))
            AddCmdParameter("@Quantity", TDevFramework.EDataType.eSmallInt, objInfo.Quantity, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Quantity"))
            AddCmdParameter("@Discount", TDevFramework.EDataType.eTinyInt, objInfo.Discount, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Discount"))

        End Function


        Private Function CheckPrimaryKeyValues(ByVal objInfo As OrderDetails) As Boolean
            If ((objInfo("OrderID").Null) And (objInfo("ProductID").Null)) Then
                Throw New Exception("Primary key must have some valid value.")
            End If
            Return True

        End Function

#End Region

#Region "LoadChildren Methods"

        Public Function LoadChildren(ByVal objInfo As OrderDetails, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        End Function

#End Region

    End Class
End Namespace
