'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


' <fileinfo name="ShippersFactory.vb">
'		<author></author>
'		<creation-datetime>Tue Jun 07 04:35:02 2005</creation-datetime>
'		<description>
'			Contains VB.NET code ShippersFactory.
'		</description>
'		<remarks>
'			Changes to this file will be lost if the code is regenerated.
'		</remarks>
' </fileinfo>
 
Imports System
Imports System.Data
Imports System.Text
Imports System.Globalization
Imports System.Resources
Imports System.Threading
Imports System.Reflection
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework 

Imports System.Data.OleDb

 Namespace NCacheSample

	Public Interface IShippersFactory
		Function Load(ByVal objInfo As Shippers, ByVal nDepth As Int32, bCacheEnalbed As Boolean)
		Function Insert(ByVal objInfo As Shippers, ByVal nDepth As Int32)
		Function Update(ByVal objInfo As Shippers, ByVal nDepth As Int32)
		Function Delete(ByVal objInfo As Shippers, ByVal nDepth As Int32)
		Function Save(ByVal objList As ShippersCollection, ByVal nDepth As Int32)
		Function DeleteColl(ByVal objList As ShippersCollection, ByVal nDepth As Int32)
		'Function ProcessDataSet(ByVal dataSet As DataSet)
		
End Interface
	
	''' <summary>
	''' Object <c>Shippers</c>Factory. Provides implementation.
	''' </summary>
	''' <remarks>
	'''		
	''' </remarks>
	<  ClassInterface(ClassInterfaceType.AutoDual)> _
	    Public Class ShippersFactory
        Inherits DbObject
        Implements IShippersFactory
		' define constants here for either dynamic SQL or stored procedure calls
		
		Private Shared _stQryObject As String 
		Private Shared _stPKQryObject As String 
		
		Private Const USE_STORE_PROC As Boolean = False
		Private Const STD_LOAD_SQL As String = _
						"SELECT" & _ 
						"     a26.[ShipperID] as ShipperID, a26.[CompanyName] as CompanyName," & _ 
						"     a26.[Phone] as Phone" & _ 
						" FROM" & _ 
						"     [Shippers] a26" & _ 
						" WHERE" & _ 
						"     [ShipperID] = ?" 
		Private Const STD_INSERT_SQL As String = _
						"INSERT INTO [Shippers]" & _ 
						"    ([CompanyName], [Phone]" & _ 
						"     ) VALUES (?, ?" & _ 
						"     )" 
		Private Const STD_DELETE_SQL As String = _
						"DELETE FROM [Shippers] WHERE [ShipperID] = ?" 
		Private Const STD_UPDATE_SQL As String = _
						"UPDATE" & _ 
						"     [Shippers]" & _ 
						" SET" & _ 
						"     [CompanyName] = ?, [Phone] = ?" & _ 
						" WHERE" & _ 
						"     [ShipperID] = ?" 
		

		
        ' second argument to base() is a flag about whether we're using stored procedures
        ' or dynamic SQL; true = storedProc, false = dynamic sql
        'TDevFramework.PropertyFile.CreateInstance("DbConnStr.db").LoadProperty("Shippers")
        Public Sub New()
            MyBase.new("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\NorthwindDB\Northwind.mdb;User Id=;Password=;", TDevFramework.EDBProvider.OLEDB)
        End Sub		
		
        	

	Public Sub New(ByVal connectionString As String)
            MyBase.new(connectionString, TDevFramework.EDBProvider.OLEDB)
        End Sub	

        Public Sub New(ByVal connection As TDevFramework.Connection)
            MyBase.new(connection)
        End Sub
        
        Public Sub New(ByVal connection As Object)
            MyBase.new(connection, TDevFramework.EDBProvider.OLEDB)
        End Sub

		#Region "[Cache Keys]"
        Private Function GetPKQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".PKQry" ' A dummy key ...
            If _stPKQryObject = "" Then
                _stPKQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stPKQryObject, Nothing)
            End If
            GetPKQueryKey = key
        End Function
        Private Function GetQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".NonPKQry" ' A dummy key ...
            If _stQryObject = "" Then
                _stQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stQryObject, Nothing)
            End If
            GetQueryKey = key
        End Function
					
		Private Sub InvalidateAll()
            NCacheUtil.Remove(GetQueryKey()) '
            _stQryObject = Nothing
        End Sub
		Private Sub Invalidate(ByVal type As NCacheUtil.InvalidateType, ByVal ParamArray relatedKeys As String())
            '_staticObject = "INVALIDATED"
            'NCacheUtil.Insert(GetStaticObjectKey(),_staticObject,Nothing)
            '_staticObject = Nothing'
            If ((type And NCacheUtil.InvalidateType.QueryCollectionPK) = NCacheUtil.InvalidateType.QueryCollectionPK) Then
                If _stPKQryObject <> "" Then
                    NCacheUtil.Remove(GetPKQueryKey())
                    _stPKQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.QueryCollection) = NCacheUtil.InvalidateType.QueryCollection) Then
                If _stQryObject <> "" Then
                    NCacheUtil.Remove(GetQueryKey())
                    _stQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.RelatedCollection) = NCacheUtil.InvalidateType.RelatedCollection) Then
			
            End If
        End Sub
		
		#End Region


		#Region  " Standard Methods "


		' <summary>
		' 	Load (Standard Load Method [Cache Enabled])
		' </summary>
		' <remarks>
		' 	Loads a record from the <c>[Shippers]</c> table given by
		' 	the specified primary key.
		' </remarks>
		' <param name="objInfo">The <c>Shippers</c> info object containing the primary key.</param>
		' <param name="nDepth">Specifies depth of children should be loaded.</param>
		Public Function Load(ByVal objInfo As Shippers, ByVal nDepth As Integer, ByVal bCacheEnable As Boolean) _
		Implements IShippersFactory.Load

            Dim objKey As String
            Dim obj As Object
            objKey = NCacheUtil.GetObjectKey("Shippers", objInfo.ShipperID.ToString())
            Try
				If bCacheEnable Then
					obj = NCacheUtil.Load(objKey) ' Check if the object is in Cache. 
					If obj Is Nothing Then ' Cache miss..
						_Load(objInfo, nDepth, bCacheEnable)
                        Stats.ObjsReadFromDB = 1
                        Stats.ReadTripsToDB = 1
						NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
						Exit Function
					End If
					Stats.ObjsReadFromCache= 1
                    Dim objTemp As Shippers = CType(obj, Shippers)
                    objInfo.Copy(objTemp) ' Cache hit..

					If nDepth <> 0 Then
						LoadChildren(objInfo, nDepth - 1, bCacheEnable)
					End If
				Else 
					_Load(objInfo,nDepth, bCacheEnable)
                    Stats.ObjsReadFromDB = 1
                    Stats.ReadTripsToDB = 1
					NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
				End If
			Catch e As Exception
                Throw e
            End Try
        End Function

		' <summary>
		' 	Load (Standard Load Method)
		' </summary>
		' <remarks>
		' 	Loads a record from the <c>[Shippers]</c> table given by
		' 	the specified primary key.
		' </remarks>
		' <param name="objInfo">The <c>Shippers</c> info object containing the primary key.</param>
		' <param name="nDepth">Specifies depth of children should be loaded.</param>
        
		
			Private Function _Load(ByVal objInfo As Shippers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
		
			Try
				Dim bRecordsFound As Boolean = False
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_LOAD_SQL, USE_STORE_PROC)
			
				AddCmdParameter("@ShipperID", TDevFramework.EDataType.eInt, objInfo.ShipperID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipperID"))
				ExecuteReader()
				while (Read())
					FillPersistentObject(objInfo)
					objInfo.IsNew = False
					objInfo.Dirty = False
					bRecordsFound = True
				End While	
				ReleaseReader()
				If Not bRecordsFound Then 
					Throw new RecordNotFoundException("No record found against given search criteria.")
				End If
				
				If (nDepth <> 0) Then
					LoadChildren(objInfo, nDepth - 1,bCacheEnable)
				End If
				
				SetStatus(EStatus.eSuccess)
				ReleaseCommand()
			
			Catch e As RecordNotFoundException
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Throw e
			Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
			End Try
		End Function


		' <summary>
		' 	Insert (Standard Insert Method)
		' </summary>
		' <remarks>
		' 	Adds a new record into the <c>[Shippers]</c> table.
		' </remarks>
		' <param name="objInfo">The <c>Shippers</c> info object to be inserted.</param>
		' <param name="nDepth">Specifies depth of children should be inserted.</param>
        
		Public Function Insert(ByVal objInfo As Shippers, ByVal nDepth As Int32) _
			Implements IShippersFactory.Insert
			Try
				
                objInfo.ValidateRequiredFields()
	
                Prepare(STD_INSERT_SQL, USE_STORE_PROC)

				If ( nDepth <> 0) Then
				End If
				'Read the persistent object
				ReadPersistentObject(objInfo)
				ExecuteNonQuery()

				Prepare("SELECT @@IDENTITY AS ShipperID;", false)
				ExecuteReader()

				If (Read ()) Then
						If (Not IsNull("ShipperID")) Then
							objInfo.ShipperID = Convert.ToInt32(getValue("ShipperID"))
						End If
				End If
				ReleaseReader()
			
				
				If ( nDepth <> 0) Then
				End If				
	
				

				SetStatus(EStatus.eSuccess)
				ReleaseCommand()
				Stats.WriteTripsToDB = 1
                objInfo.IsNew = False
                objInfo.Dirty = False

                Dim objKey As String
                objKey = NCacheUtil.GetObjectKey("Shippers", objInfo.ShipperID.ToString())

				NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
				Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK AND NCacheUtil.InvalidateType.QueryCollection,Nothing)
				
			Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
			End Try
		End Function

		' <summary>
		' 	Delete (Standard Delete Method)
		' </summary>
		' <remarks>
		' 	Deletes the record in <c>[Shippers]</c> table given
		'   by its primary key.
		' </remarks>
		' <param name="objInfo">The <c>Shippers</c> info object used to delete the record.</param>
		' <param name="nDepth">Specifies depth of children should be deleted.</param>
        
		Public Function Delete(ByVal objInfo As Shippers, ByVal nDepth As Int32) _
			Implements IShippersFactory.Delete
			Try
			
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_DELETE_SQL, USE_STORE_PROC)	
			
				If (nDepth <> 0) Then
				End If
				AddCmdParameter("@ShipperID", TDevFramework.EDataType.eInt, objInfo.ShipperID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipperID"))
				ExecuteNonQuery()
				Stats.WriteTripsToDB = 1

				
				SetStatus(EStatus.eSuccess)
				ReleaseCommand()

                Dim objKey As String
                objKey = NCacheUtil.GetObjectKey("Shippers", objInfo.ShipperID.ToString())

				NCacheUtil.Remove(objKey) ' Invalidating all PK query Collections and the Related Collection...
				Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Remove all the NonPK/Partial collections
				
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


		' <summary>
		' 	Update (Standard Update Method)
		' </summary>
		' <remarks>
		' 	Updates the record in <c>[Shippers]</c> table given
		' by its primary key.
		' </remarks>
		' <param name="objInfo">The <c>Shippers</c> info object used to update the record.</param>
		' <param name="nDepth">Specifies depth of children should be updated.</param>
        
		Public Function Update(ByVal objInfo As Shippers, ByVal nDepth As Int32) _
			Implements IShippersFactory.Update
			Try
				
                CheckPrimaryKeyValues(objInfo)
               
				objInfo.ValidateRequiredFields()
			Prepare(STD_UPDATE_SQL, USE_STORE_PROC)
				If (nDepth <> 0) Then
				End If
				ReadPersistentObject(objInfo)
				AddCmdParameter("@ShipperID", TDevFramework.EDataType.eInt, objInfo.ShipperID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ShipperID"))

				ExecuteNonQuery()
				Stats.WriteTripsToDB = 1

				
				If (nDepth <> 0) Then
				End If
				SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.Dirty = False

                Dim objKey As String
                objKey = NCacheUtil.GetObjectKey("Shippers", objInfo.ShipperID.ToString())

                NCacheUtil.Remove(objKey)  ' Invalidating RElated Collection PKQueryCollection...
                Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK
                ' adding the copy of this object in Cache.. 
                NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function
		
		#End Region
		
		
		Public Function Save(ByVal objList As ShippersCollection, ByVal nDepth As Int32) _
            Implements IShippersFactory.Save
		
	    Dim objInfo As Shippers = Nothing
            Dim count As Integer
            
            For count = 0 To  objList.Count - 1
                objInfo = objList(count)
                
                If (objInfo.IsNew) Then
                    Me.Insert(objInfo, nDepth)
                ElseIf (objInfo.Dirty) Then
                    Me.Update(objInfo, nDepth)
                
                End If
                
                
            Next count
			
            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Shippers)
                Me.Delete(objInfo, nDepth)
            Next count
		End Function

		
		' <summary>
		' 	DeleteColl (Standard Collection Delete Method)
		' </summary>
		' <remarks>
		' 	Performs standard delete on a collection of <c>Shippers</c> objects.
		' </remarks>
		' <param name="objList">The <c>ShippersCollection</c> object.</param>
		' <param name="nDepth">integer that is passed to each delete operation.</param>		
		
		Public Function DeleteColl(ByVal objList As ShippersCollection, ByVal nDepth As Int32) _
            Implements IShippersFactory.DeleteColl
			
            Dim objInfo As Shippers = Nothing
            Dim count As Integer
            
            For count = 0 To  objList.Count - 1
                objInfo = objList(count)
                If (Not objInfo.IsNew) Then
                    Me.Delete(objInfo, nDepth)
                End If
            Next count
            
            For count = 0 To  objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Shippers)
                Me.Delete(objInfo, nDepth)
            Next count  
            
	End Function
			
		

	#Region " Queries "

		#End Region

		#Region " Bulk Update Operations "

		#End Region

		#Region " Bulk Delete Operations "

		#End Region

		#Region " Custom Insert Operations "

		#End Region

		#Region " Custom Update Operations "

		#End Region

		#Region " Custom Load Operations "

		#End Region

		#Region " Stored Procedures "
	
		#End Region

		#Region " Utility Methods "

		Private Function FillPersistentObject(ByVal objInfo As Shippers)
		
			If (Not IsNull("ShipperID")) Then
				objInfo.ShipperID = Convert.ToInt32(getValue("ShipperID"))
			End If
			If (Not IsNull("CompanyName")) Then
				objInfo.CompanyName = Convert.ToString(getValue("CompanyName"))
			End If
			If (Not IsNull("Phone")) Then
				objInfo.Phone = Convert.ToString(getValue("Phone"))
			End If
		
		End Function

		Private Function ReadPersistentObject(objInfo As Shippers)
		
			AddCmdParameter("@CompanyName", TDevFramework.EDataType.eVarchar, objInfo.CompanyName, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("CompanyName"))
			AddCmdParameter("@Phone", TDevFramework.EDataType.eVarchar, objInfo.Phone, TDevFramework.EParamDirection.eInput,  objInfo.IsNull("Phone"))
		
		End Function
		
		
        	Private Function CheckPrimaryKeyValues(ByVal objInfo As Shippers) As Boolean
		If ((objInfo("ShipperID").Null)) Then
				Throw New Exception("Primary key must have some valid value.")
			End If
            Return True
            
        End Function
        
		#End Region
		
		#Region "LoadChildren Methods"

		Public Function LoadChildren(ByVal objInfo As Shippers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) 
		End Function
		
		#End Region
        
    End Class
End Namespace
