'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.Resources
Imports System.Collections
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IShippers
		
	
		Property ShipperID() As Int32
		Property CompanyName() As String
		Property Phone() As String
	End Interface
	
	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class Shippers 
		        Inherits PersistentObject
				Implements IShippers, IComparable 
	
        Public Sub New()
            SetupFields()
        End Sub

		
		' <summary>
		' Gets or sets the <c>ShipperID</c> attribute value.
		' </summary>
		' <value>The <c>ShipperID</c> attribute value.</value>
        Public Property ShipperID() As Int32 _
            Implements IShippers.ShipperID
			Get
                If (Not me("ShipperID").Null) Then
                    Return CType(me("ShipperID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("ShipperID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>CompanyName</c> attribute value.
		' </summary>
		' <value>The <c>CompanyName</c> attribute value.</value>
        Public Property CompanyName() As String _
            Implements IShippers.CompanyName
			Get
                If (Not me("CompanyName").Null) Then
                    Return CType(me("CompanyName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("CompanyName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Phone</c> attribute value.
		' </summary>
		' <value>The <c>Phone</c> attribute value.</value>
        Public Property Phone() As String _
            Implements IShippers.Phone
			Get
                If (Not me("Phone").Null) Then
                    Return CType(me("Phone").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Phone").Value = Value
			End Set
		End Property
		Public  Function  SetNull(ByVal szFieldName As String ,ByVal bNull As Boolean)
			me(szFieldName).Null = bNull
		End Function

		Public  Function  IsNull(ByVal szFieldName As String) As Boolean
			Return me(szFieldName).Null
		End Function

        Public Overloads Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Try
                If TypeOf obj Is Shippers Then
                    Dim cmpShippers As Shippers = CType(obj, Shippers)

                    If ShipperID.CompareTo(cmpShippers.ShipperID) = 0 _
                     AndAlso CompanyName.CompareTo(cmpShippers.CompanyName) = 0 Then
                        Return 1
                    Else
                        Return 0
                    End If
                End If
            Catch ex As Exception
                Throw New ArgumentException("object is not an instance of Shippers")
            End Try
            
        End Function
        Private Function SetupFields()

            AddField(New PersistentField("ShipperID", True, True, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("CompanyName", True, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("Phone", False, False, TDevFramework.EDataType.eVarchar))
        End Function

        Public Sub Copy(ByVal objInfo As Shippers)
            Me.ShipperID = objInfo.ShipperID
            Me.CompanyName = objInfo.CompanyName
            Me.Phone = objInfo.Phone
            'Me.Dirty = objInfo.Dirty
            'Me.IsNew = objInfo.IsNew
        End Sub
    End Class
End Namespace